function [Dxu] = DxAllLowLevConstrs(obj,i,x,y)
    %Dxu=DxAllLowLevConstrs(i,x,y) returns the derivative of the function
    %evalAllLowLevConstrs with respect to x. 


    Dxu=zeros(0,obj.nrOfUppLevVars);
    if obj.nrOfLowLevNonlinConstrs(i)>0
        Dxu=[Dxu;obj.DxLowLevNonlinConstrs(i,x,y)];
    end
    %Add the linear constraints    
    [A,b]=obj.getLinIneqsOnLowLevVars(i,x);
    [DxA,Dxb]=obj.DxLinIneqsOnLowLevVars(i,x);
    nrLinIneqs=size(A,1);
    DxAAsMatrix=reshape(DxA,[obj.nrOfUppLevVars*nrLinIneqs,obj.nrOfLowLevVars]);
    %vector to extract right rows
    indexVector=(0:(obj.nrOfUppLevVars-1))*nrLinIneqs;
    for i=1:nrLinIneqs
        Dxu=[Dxu;(DxAAsMatrix(indexVector+i,:)*y')'-Dxb(i,:)]; 
    end
    
    %Add the boundaries
    [lb,ub]=obj.getBoundsOnLowLevVars(i,x);
    [Dxlb,Dxub]=obj.DxBoundsOnLowLevVars(i,x);
    constrlb=lb-y;
    %drop the boundaries with -inf
    constrlb=constrlb(constrlb~=-inf);
    nrconstrlb=length(constrlb);
    Dxlb=Dxlb(constrlb~=-inf,:);
    Dxu=[Dxu;Dxlb];
    
    construb=y-ub;
    construb=construb(construb~=-inf);
    nrconstrub=length(construb);
    Dxub=Dxub(construb~=-inf,:);
    Dxu=[Dxu;-Dxub];


end

