function [ DxDxg ] = DxDxAllUppLevIneqConstrs(obj, x )
    %DxDxg=DxDxAllUppLevIneqConstrs(x) returns the seccond derivative of the
    %function evalAllUppLevIneqConstrs with respect to x. 


    DxDxg=zeros(0,obj.nrOfUppLevVars,obj.nrOfUppLevVars);
    if obj.nrOfLowLevNonlinConstrs>0
        DxDxg=obj.DxDxUppLevNonlinIneqConstrs(x);
    end
    
    %Add the linear constraints    
    [A,b]=obj.getLinIneqsOnUppLevVars();
    nrLinIneqs=size(A,1);
    if nrLinIneqs>0
        DxDxg=[DxDxg;zeros(nrLinIneqs,obj.nrOfUppLevVars,obj.nrOfUppLevVars)]; 
    end
    
     %Add the boundaries
    [lb,ub]=obj.getBoundsOnUppLevVars();
    constrlb=lb-x;
    %drop the boundaries with -inf
    constrlb=constrlb(constrlb~=-inf);
    nrconstrlb=length(constrlb);
    DxDxg=[DxDxg;zeros(nrconstrlb,obj.nrOfUppLevVars,obj.nrOfUppLevVars)];
    
    construb=x-ub;
    construb=construb(construb~=-inf);
    nrconstrub=length(construb);
    DxDxg=[DxDxg;zeros(nrconstrub,obj.nrOfUppLevVars,obj.nrOfUppLevVars)];

    
   
    

end

