function [h] = implicitPlotOfOptValueFunction2Variables( problem,i,IndexDraw,Bounds,ValsOthers,numberOfEvaluatedPoints)
%Please use the function implicitPlotOfOptValueFunction. This function does
%not check the correctness of inputs

%make sure that the first index is the lower one
if IndexDraw(1)>IndexDraw(2)
    temp=IndexDraw(1);
    IndexDraw(1)=IndexDraw(2);
    IndexDraw(2)=temp;
    temp=Bounds(:,1);
    Bounds(:,1)=Bounds(:,2);
    Bounds(:,2)=temp;  
end
NrPointsInDir=ceil(sqrt(numberOfEvaluatedPoints));
%initialize the y Values and the xValues
yValues=zeros(NrPointsInDir,NrPointsInDir,size(i,2));
xValues1=linspace(Bounds(1,1),Bounds(2,1),NrPointsInDir);
xValues2=linspace(Bounds(1,2),Bounds(2,2),NrPointsInDir);

%Settings for the solver
myLLPfminconOptions = optimset('Algorithm', 'sqp');
myLLPfminconOptions = optimset(myLLPfminconOptions, 'Display', 'off');
myLLPfminconOptions = optimset(myLLPfminconOptions, 'MaxFunEvals', Inf);
myLLPfminconOptions = optimset(myLLPfminconOptions, 'MaxIter', 1000);
myLLPfminconOptions = optimset(myLLPfminconOptions, 'FunValCheck', 'on');
%myLLPfminconOptions = optimset(myLLPfminconOptions, 'GradObj', 'on', 'GradConstr', 'on', 'DerivativeCheck', der_check);
myLLPfminconOptions = optimset(myLLPfminconOptions, 'ScaleProblem', 'obj-and-constr');
myLLPfminconOptions = optimset(myLLPfminconOptions, 'FinDiffType', 'central');

for j=1:NrPointsInDir
    for j2=1:NrPointsInDir
        for j3=1:size(i,2)
            index=i(j3);
            x_temp=[ValsOthers(1:IndexDraw(1)-1),xValues1(j),ValsOthers(IndexDraw(1):IndexDraw(2)-2),...
                xValues2(j2),ValsOthers(IndexDraw(2)-1:end)];


        %optimization of every lower level problem

            k=problem.getIndexSetOfSemiInfConstr(index);   
            Yint = problem.getInitValsLowLevVars(k,x_temp);
            [lbl, ubl] = problem.getBoundsOnLowLevVars(k,x_temp);
            [Aineq,bineq] = problem.getLinIneqsOnLowLevVars (k,x_temp);
            % max-problem    
            [~,fval] = fmincon(@LLPObjFun,Yint,Aineq,bineq,[],[],lbl,ubl,@LLPConFuns,myLLPfminconOptions,problem,index,x_temp,k);
            yValues(j2,j,j3)=-fval;
            if mod((j-1)*NrPointsInDir+j2,10)==0 && j3==size(i,2)
               fprintf('The first %i points are computed\n',(j-1)*NrPointsInDir+j2);
            end
        end
    end
end
figure;
%compute the maximum
yValues=max(yValues,[],3);
%mesh(xValues1,xValues2,yValues);
h=surf(xValues1,xValues2,yValues);
%colormap(winter)
%colormap(gray)
colormap(cool)
%set(h,'facecolor','blue')
xlabel('Parameter 1');
ylabel('Parameter 2');
zlabel('Values of the optimal value function');
title('optimal value function')
    
    
%objective function of the lower level
function [g, grad_g_y] = LLPObjFun(y,GSIP_problem2,i,xval,~)
   
    g_temp = GSIP_problem2.evalSemiInfConstrs(i,xval,y);
    g=-g_temp; %max-problem
    
    
    grad_g_y_temp = GSIP_problem2.DySemiInfConstrs(i,xval,y);
    grad_g_y=-grad_g_y_temp';
end

%constraints of the lower level problem
function [u, h, grad_u, grad_h] = LLPConFuns(y,GSIP_problem2,~,xval,k2)
      
    h = [];
    grad_h = [];
    assert(size(y,1)==1);
    u = GSIP_problem2.evalLowLevNonlinConstrs(k2,xval,y);
    
    grad_u = GSIP_problem2.DyLowLevNonlinConstrs(k2,xval,y)';

end
    

end

