function [] = checkContainer( container,checkDeriv,checkSecDeriv)
%checkContainer(c,checkDeriv,checkSecDeriv) checks all functions of the
%Container c. If a output has the wrong size or an inconsistent value a
%warning is thrown. It may happen, that in a first run only a few warnings
%are thrown. If they are corrected more mistakes may be found. If
%checkDeriv is 1, derivatives are checked. if checkSecDeriv is 1, seccond
%derivatives are checked.

       bBoundingBox=1;
       
       bgetNrDescrFuns=checkOneFunction(container,'getNrDescrFuns',{[1;1]});
       bdim=checkOneFunction(container,'getDim',{[1;1]});
       if bdim
           dim=container.getDim();
           
           bBoundingBox=checkOneFunction(container,'getBoundingBox',{[1,dim],[1;dim]});
           
           if bgetNrDescrFuns && bBoundingBox
               nrOfConstFuns=container.getNrDescrFuns;
               [lb,ub]=container.getBoundingBox;
               y=(lb+ub)/2;
             %  Input{2}=y;
               bevalDescrFuns=1;
               bDyDescrFuns=1;
                for i=1:nrOfConstFuns
              %      Input{1}=i;
                    bevalDescrFuns=min(bevalDescrFuns,checkOneFunction(container,'evalDescrFuns',{[1;1]},i,y));
                    
                    bDyDescrFuns=min(bDyDescrFuns,checkOneFunction(container,'DyDescrFuns',{[1;dim]},i,y)); 
                end
                if bevalDescrFuns && checkDeriv
                    bevalDescrFuns=min(bevalDescrFuns,checkOneFunctionDerivative(container,'DyDescrFuns',0,'evalDescrFuns',2,{[]},i,0,y,1));
                end
                if bevalDescrFuns && checkSecDeriv
                    bevalDescrFuns=min(bevalDescrFuns,checkOneFunctionSecDerivative(container,'DyDyDescrFuns','evalDescrFuns',2,{[]},i,0,y,1));
                end
           end
           
       end
       allcorrect=min([bdim,bgetNrDescrFuns,bBoundingBox,bevalDescrFuns,bDyDescrFuns]);

if allcorrect
    disp('All methods passed the test');
end
    
    
end

